<?php
namespace PhpOffice\PhpWord\Element;

class Inline extends AbstractElement {
    protected $comments = array();
    protected $revision = null;

    public function setAnnotations($style)
    {
        if ( $style instanceof \PhpOffice\PhpWord\Style\Font ) {
            $this->setComments($style->getSynocomment());
            $this->setRevision($style->getRevision());
        } else {
            $this->setComments($style['synocomment']);
            $this->setRevision($style['revision']);
        }
    }

    protected function setComments($comments)
    {
        global $comment;

        if (!is_array($comments)) {
            return;
        }
        $this->comments = $comments;
        if (!is_array($comment)) {
            return;
        }
        foreach ($comments as $id) {
            if (!array_key_exists($id, $comment)) {
                continue;
            }
            if (!array_key_exists('@begin', $comment[$id])) {
                $comment[$id]['@begin'] = $this;
            }
            $comment[$id]['@end'] = $this;
            if ( is_null($comment[$id]['replies']) ) {
                continue;
            }

            // handle replies as comments
            foreach($comment[$id]['replies'] as $r) {
                $this->comments[] = $r['id'];
                if (!array_key_exists($r['id'], $comment)) {
                    continue;
                }
                if (!array_key_exists('@begin', $comment[$r['id']])) {
                    $comment[$r['id']]['@begin'] = $this;
                }
                $comment[$r['id']]['@end'] = $this;
            }
        }
    }

    protected function setRevision($revision)
    {
        if (!is_array($revision)) {
            return;
        }
        $this->revision = $revision;
    }

    public function getComments()
    {
        return $this->comments;
    }

    public function getRevision()
    {
        return $this->revision;
    }
}
